> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.gappify.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.gappify.com/_mcp/server.

# Create a new or update existing Transactions entries.

POST https://api.gappify.com/v1/transactions
Content-Type: application/json

Create a new or update existing Transactions entries with the provided data.

## Required Fields Summary

| Field                     | Type   | Description                                                                              |
| ------------------------- | ------ | ---------------------------------------------------------------------------------------- |
| `source_system_id`        | string | ERP id which uniquely represents the specific transaction line record                    |
| `date`                    | date   | Transaction date (YYYY-MM-DD)                                                            |
| `period`                  | date   | Accounting period where journal/invoice was posted. ⚠️ **Required format:** `yyyy-mm-01` |
| `type`                    | string | Presents the type of GL transaction                                                      |
| `subsidiary_currency_id`  | string | Subsidiary currency id of the posted transaction line                                    |
| `transaction_currency_id` | string | Currency id in which the transaction was posted                                          |
| `amount`                  | double | Amount of the GL transaction in transaction currency                                     |
| `transaction_amount`      | double | Amount of the GL transaction in transaction currency                                     |
| `subsidiary_amount`       | double | Amount of the transaction in subsidiary base currency                                    |

If using the **Insights Module**, the following fields are also required:

* `vendor_id`
* `subsidiary_id`

Reference: https://developers.gappify.com/api-reference/inbound-to-gappify/5/post

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.gappify.com/v1` (Production, default)
- `https://api.uat.gappifyinc.com/v1` (UAT)

## Request

### Body (application/json)

This endpoint expects a list of TransactionsPostPayload.

- `list of TransactionsPostPayload`

## Response

### 202

- `request_id` (UUID, required) — Unique identifier for the request
- `status` ("IN_PROGRESS", required) — Status of the request

## Errors

### 401 Unauthorized Error

- `message` (string, required) — The error message
- `success` (boolean, required)

### 422 Unprocessable Entity Error

- `message` (string, required) — The error message
- `errors` (string, required) — The error details

### 404 Not Found Error

- `list of string`

### 500 Internal Server Error

- `list of string`

## Types

### TransactionsPostPayload

- `source_system_id` (string, required) — ERP id which uniquely represents the specific transaction line record. This value will be used to match source data and perform upserts.
- `date` (date, required) — Transaction date. Should be in the format YYYY-MM-DD.
- `period` (date, required) — Accounting period where journal / invoice was posted. **Format:** `yyyy-mm-01` (e.g., `2026-03-01`).
- `type` (string, required) — Presents the type of gl transaction.
- `subsidiary_currency_id` (string, required) — Subsidiary currency id of the posted transaction line in the gl. Should match the name in the currency list of source_coas.
- `transaction_currency_id` (string, required) — Currency id in which the transaction was posted in the gl. Should match the g_source_system_id in the currency list of source_coas.
- `amount` (double, required) — Amount of the gl transaction as presented in the transaction currency.
- `transaction_amount` (double, required) — Amount of the gl transaction as presented in the transaction currency.
- `subsidiary_amount` (double, required) — Amount of the transaction as translated to the base currency of the subsidiary.
- `subsidiary_id` (string, optional) — Expense subsidiary id linked to the gl transaction. This value should match the g_source_system_id in source_coas.
- `vendor_id` (string, optional) — Id of the Vendor/Supplier. This value should match the source_vendors->g_source_system_id.
- `document_number` (string, optional) — Invoice/Bill Number, Journal Name, Other transaction reference number.
- `glaccount_number` (integer, optional) — Expense glacocunt number
- `glaccount_id` (string, optional) — Expense glaccount id linked to the gl transaction line. This value should match the g_source_system_id in source_coas.
- `memo` (string, optional) — Journal Line Description, Invoice line description
- `exchange_rate` (double, optional) — Exchange rate applied on the transaction line.
- `department_id` (string, optional) — Expense department id linked to the gl transaction line. This value should match the g_source_system_id in source_coas.
- `gappify_id` (integer, optional) — Gappify id stamped on the JE that was posted.
- `po_id` (string, optional) — PO number associated with the AP invoice (if any). Blank for GL Journal. Should match the g_po_id in the source_purchase_orders.
- `company_id` (integer, optional) — Expense company id linked to the gl transaction line. This value should match the g_source_system_id in source_coas.

## Examples

**Request**

```json
[
  {
    "source_system_id": "source_system_id",
    "date": "2023-01-15",
    "period": "2023-01-15",
    "type": "type",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "transaction_currency_id": "transaction_currency_id",
    "amount": 1.1,
    "transaction_amount": 1.1,
    "subsidiary_amount": 1.1
  },
  {
    "source_system_id": "source_system_id",
    "date": "2023-01-15",
    "period": "2023-01-15",
    "type": "type",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "transaction_currency_id": "transaction_currency_id",
    "amount": 1.1,
    "transaction_amount": 1.1,
    "subsidiary_amount": 1.1
  }
]
```

**Response**

```json
{
  "request_id": "d5e9c84f-c2b2-4bf4-b4b0-7ffd7a9ffc32",
  "status": "IN_PROGRESS"
}
```

**SDK Code**

```python
import requests

url = "https://api.gappify.com/v1/transactions"

payload = [
    {
        "source_system_id": "source_system_id",
        "date": "2023-01-15",
        "period": "2023-01-15",
        "type": "type",
        "subsidiary_currency_id": "subsidiary_currency_id",
        "transaction_currency_id": "transaction_currency_id",
        "amount": 1.1,
        "transaction_amount": 1.1,
        "subsidiary_amount": 1.1
    },
    {
        "source_system_id": "source_system_id",
        "date": "2023-01-15",
        "period": "2023-01-15",
        "type": "type",
        "subsidiary_currency_id": "subsidiary_currency_id",
        "transaction_currency_id": "transaction_currency_id",
        "amount": 1.1,
        "transaction_amount": 1.1,
        "subsidiary_amount": 1.1
    }
]
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.gappify.com/v1/transactions';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '[{"source_system_id":"source_system_id","date":"2023-01-15","period":"2023-01-15","type":"type","subsidiary_currency_id":"subsidiary_currency_id","transaction_currency_id":"transaction_currency_id","amount":1.1,"transaction_amount":1.1,"subsidiary_amount":1.1},{"source_system_id":"source_system_id","date":"2023-01-15","period":"2023-01-15","type":"type","subsidiary_currency_id":"subsidiary_currency_id","transaction_currency_id":"transaction_currency_id","amount":1.1,"transaction_amount":1.1,"subsidiary_amount":1.1}]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.gappify.com/v1/transactions"

	payload := strings.NewReader("[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"date\": \"2023-01-15\",\n    \"period\": \"2023-01-15\",\n    \"type\": \"type\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"transaction_currency_id\": \"transaction_currency_id\",\n    \"amount\": 1.1,\n    \"transaction_amount\": 1.1,\n    \"subsidiary_amount\": 1.1\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"date\": \"2023-01-15\",\n    \"period\": \"2023-01-15\",\n    \"type\": \"type\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"transaction_currency_id\": \"transaction_currency_id\",\n    \"amount\": 1.1,\n    \"transaction_amount\": 1.1,\n    \"subsidiary_amount\": 1.1\n  }\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.gappify.com/v1/transactions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"date\": \"2023-01-15\",\n    \"period\": \"2023-01-15\",\n    \"type\": \"type\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"transaction_currency_id\": \"transaction_currency_id\",\n    \"amount\": 1.1,\n    \"transaction_amount\": 1.1,\n    \"subsidiary_amount\": 1.1\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"date\": \"2023-01-15\",\n    \"period\": \"2023-01-15\",\n    \"type\": \"type\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"transaction_currency_id\": \"transaction_currency_id\",\n    \"amount\": 1.1,\n    \"transaction_amount\": 1.1,\n    \"subsidiary_amount\": 1.1\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.gappify.com/v1/transactions")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"date\": \"2023-01-15\",\n    \"period\": \"2023-01-15\",\n    \"type\": \"type\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"transaction_currency_id\": \"transaction_currency_id\",\n    \"amount\": 1.1,\n    \"transaction_amount\": 1.1,\n    \"subsidiary_amount\": 1.1\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"date\": \"2023-01-15\",\n    \"period\": \"2023-01-15\",\n    \"type\": \"type\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"transaction_currency_id\": \"transaction_currency_id\",\n    \"amount\": 1.1,\n    \"transaction_amount\": 1.1,\n    \"subsidiary_amount\": 1.1\n  }\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.gappify.com/v1/transactions', [
  'body' => '[
  {
    "source_system_id": "source_system_id",
    "date": "2023-01-15",
    "period": "2023-01-15",
    "type": "type",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "transaction_currency_id": "transaction_currency_id",
    "amount": 1.1,
    "transaction_amount": 1.1,
    "subsidiary_amount": 1.1
  },
  {
    "source_system_id": "source_system_id",
    "date": "2023-01-15",
    "period": "2023-01-15",
    "type": "type",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "transaction_currency_id": "transaction_currency_id",
    "amount": 1.1,
    "transaction_amount": 1.1,
    "subsidiary_amount": 1.1
  }
]',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.gappify.com/v1/transactions");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"date\": \"2023-01-15\",\n    \"period\": \"2023-01-15\",\n    \"type\": \"type\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"transaction_currency_id\": \"transaction_currency_id\",\n    \"amount\": 1.1,\n    \"transaction_amount\": 1.1,\n    \"subsidiary_amount\": 1.1\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"date\": \"2023-01-15\",\n    \"period\": \"2023-01-15\",\n    \"type\": \"type\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"transaction_currency_id\": \"transaction_currency_id\",\n    \"amount\": 1.1,\n    \"transaction_amount\": 1.1,\n    \"subsidiary_amount\": 1.1\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  [
    "source_system_id": "source_system_id",
    "date": "2023-01-15",
    "period": "2023-01-15",
    "type": "type",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "transaction_currency_id": "transaction_currency_id",
    "amount": 1.1,
    "transaction_amount": 1.1,
    "subsidiary_amount": 1.1
  ],
  [
    "source_system_id": "source_system_id",
    "date": "2023-01-15",
    "period": "2023-01-15",
    "type": "type",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "transaction_currency_id": "transaction_currency_id",
    "amount": 1.1,
    "transaction_amount": 1.1,
    "subsidiary_amount": 1.1
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.gappify.com/v1/transactions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```